<?php
// $Id: admin.config.php,v 1.8 2003/10/01 11:05:35 eddieajau Exp $
/**
* Config admin
* @package Mambo Open Source
* @Copyright (C) 2000 - 2003 Miro International Pty Ltd
* @ All rights reserved
* @ Mambo Open Source is Free Software
* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html
* @version $Revision: 1.8 $
**/

// ensure this file is being included by a parent file
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class mosConfig extends mosDBTable {
	var $config_editor=null;
	var $config_offline=null;
	var $config_host=null;
	var $config_user=null;
	var $config_password=null;
	var $config_db=null;
	var $config_dbprefix=null;
	var $config_lang=null;
	var $config_defaultpage=null;
	var $config_path=null;
	var $config_live_site=null;
	var $config_sitename=null;
	var $config_auth=null;
	var $config_lifetime=null;
	var $config_offline_message=null;
	var $config_usebanner=null;
	var $config_emailpass=null;
	var $config_metadesc=null;
	var $config_metakeys=null;
	var $config_debug=0;
	var $config_locale=null;
	var $config_offset=null;
	var $config_hideauthor=null;
	var $config_hidecreate=null;
	var $config_hidemodify=null;
	var $_alias=null;

	function mosConfig() {
		$this->_alias = array(
		'config_editor'			=>'mosConfig_editor',
		'config_offline'		=>'mosConfig_offline',
		'config_host'			=>'mosConfig_host',
		'config_user'			=>'mosConfig_user',
		'config_password'		=>'mosConfig_password',
		'config_db'				=>'mosConfig_db',
		'config_dbprefix'		=>'mosConfig_dbprefix',
		'config_lang'			=>'mosConfig_lang',
		'config_defaultpage'	=>'mosConfig_defaultpage',
		'config_path'			=>'mosConfig_absolute_path',
		'config_live_site'		=>'mosConfig_live_site',
		'config_sitename'		=>'mosConfig_sitename',
		'config_auth'			=>'mosConfig_shownoauth',
		'config_emailpass'		=>'mosConfig_emailpass',
		'config_offline_message'=>'mosConfig_offline_message',
		'config_usebanner'		=>'mosConfig_UseBanner',
		'config_lifetime'		=>'mosConfig_lifetime',
		'config_metadesc'		=>'mosConfig_MetaDesc',
		'config_metakeys'		=>'mosConfig_MetaKeys',
		'config_debug' 			=>'mosConfig_debug',
		'config_locale'			=>'mosConfig_locale',
		'config_offset'			=>'mosConfig_offset',
		'config_hideauthor'			=>'mosConfig_hideAuthor',
		'config_hidecreate'			=>'mosConfig_hideCreateDate',
		'config_hidemodify'			=>'mosConfig_hideModifyDate'
		);
	}

	function getVarText() {
		$txt = '';
		foreach ($this->_alias as $k=>$v) {
			if (!get_magic_quotes_gpc()) {
				$txt .= "\$$v = \"".addslashes( $this->$k )."\";\n";
			} else {
				$txt .= "\$$v = \"".$this->$k."\";\n";
			}
		}
		return $txt;
	}

	function bindGlobals() {
		foreach ($this->_alias as $k=>$v) {
			if(isset($GLOBALS[$v]))
			$this->$k = $GLOBALS[$v];
			else
			$this->$k = "";
		}
	}
}

require_once("components/com_config/admin.config.html.php");
$confightml = new HTML_config();


switch ($task) {
	case "save":
	saveconfig();
	break;

	default:
	showconfig($confightml, $database, $option);
	break;
}


function showconfig($confightml, &$database, $option) {

	$row = new mosConfig();
	$row->bindGlobals();

	// compile list of the languages
	$langs = array();
	$menuitems = array();

	if ($handle=opendir("../language/")) {
		$i=0;
		while ($file = readdir($handle)) {
			if (!strcasecmp(substr($file,-4),".php") && $file <> "." && $file <> "..") {
				$langs[] = mosHTML::makeOption( substr($file,0,-4) );
			}
		}
	}

	// sort list of languages
	sort($langs);
	reset($langs);

	// build the html select list
	$langlist = mosHTML::selectList( $langs, 'config_lang', 'class="inputbox" size="1"',
	'value', 'text', $row->config_lang );

	// make a generic yes no list
	$yesno[] = mosHTML::makeOption( '0', 'No' );
	$yesno[] = mosHTML::makeOption( '1', 'Yes' );

	// make a generic -24 - 24 list
	for ($i=-24;$i<=24;$i++) {
		$timeoffset[] = mosHTML::makeOption( $i, $i );
	}

	// get list of menuitems
	$database->setQuery( "SELECT id AS value, name AS text FROM #__menu"
	. "\nWHERE (type='content_section' OR type='components' OR type='content_typed')"
	. "\nAND published=1 AND access=0 ORDER BY name" );
	$menuitems = array_merge( $menuitems, $database->loadObjectList() );
	$defpagelist = mosHTML::selectList( $menuitems, 'config_defaultpage', 'class="inputbox" size="1";"',
	'value', 'text', $row->config_defaultpage );

	// build the html select lists
	$offlist = mosHTML::selectList( $yesno, 'config_offline', 'class="inputbox" size="1"',
	'value', 'text', $row->config_offline );

	$authlist = mosHTML::selectList( $yesno, 'config_auth', 'class="inputbox" size="1"',
	'value', 'text', $row->config_auth );

	$emailpasslist = mosHTML::selectList( $yesno, 'config_emailpass', 'class="inputbox" size="1"',
	'value', 'text', $row->config_emailpass );

	$bannerlist = mosHTML::selectList( $yesno, 'config_usebanner', 'class="inputbox" size="1"',
	'value', 'text', $row->config_usebanner );

	$debuglist = mosHTML::selectList( $yesno, 'config_debug', 'class="inputbox" size="1"',
	'value', 'text', $row->config_debug );

	$offsetlist = mosHTML::selectList( $timeoffset, 'config_offset', 'class="inputbox" size="1"',
	'value', 'text', $row->config_offset );

	$hideauthlist = mosHTML::selectList( $yesno, 'config_hideauthor', 'class="inputbox" size="1"',
	'value', 'text', $row->config_hideauthor );

	$hidecreatelist = mosHTML::selectList( $yesno, 'config_hidecreate', 'class="inputbox" size="1"',
	'value', 'text', $row->config_hidecreate );

	$hidemodifylist = mosHTML::selectList( $yesno, 'config_hidemodify', 'class="inputbox" size="1"',
	'value', 'text', $row->config_hidemodify );

	$confightml->showconfig( $row, $langlist, $offlist, $authlist, $emailpasslist, $bannerlist, $debuglist, $defpagelist, $offsetlist, $hideauthlist, $hidecreatelist, $hidemodifylist, $option );
}

function saveconfig() {

	$row = new mosConfig();
	if (!$row->bind( $_POST )) {
		mosRedirect( "index2.php", $row->getError() );
	}

	$config = "<?php\n";

	$config .= $row->getVarText();
	$config .= "setlocale (LC_TIME, \$mosConfig_locale);\n";
	$config .= "?>";

	if ($fp = fopen("../configuration.php", "w")) {
		fputs($fp, $config, strlen($config));
		fclose ($fp);

		mosRedirect( "index2.php", "The configuration details have been updated!" );
	} else {
		mosRedirect( "index2.php", "An Error Has Occurred!\nUnable to open config file to write!" );
	}
}
?>